Imports System.IO
Imports System.Math


Module SunDriver
    'Dim Wx As New TMYcls

    Public Const RadPerDeg = 1 / 57.296
    Public Const DegPerRad = 57.296

    Sub Main()

        '??? This first part has noting to do with the SunTool -- just a test of using classes defined in 
        '     other projects 
        ' Try using the TMYcls from here 
        ' Added the file TMYcls.vb to this project on project menu as "existing item"
        ' This works OK -- reads file, and displays wx for that day
        ' VB actually copies the TMYcls.vb file over to this project -- so maybe not best way
        'Wx.ReadTMYFile()
        'Wx.WxAtIx(56)

        'Dim S As New SunCls


        Dim Day As Integer = 21
        Dim Month As Integer = 4
        Dim Year As Integer = 2001
        Dim AST As Double = 12
        Dim Longa As Double = 0
        Dim lat As Double = 45 / 57.3
        Dim Alt As Double = 5000

        Dim S As New SunCls(Day, Month, Year, AST, Longa, lat, Alt)

        S.Dump()

        Console.ReadLine()

        ' For a collector panel sloped at 15 deg to the West, what is the total irradation
        ' on the panel for a day

        ' Vector normal to collector panel base on Azimuth and Elevation angles
        Dim sw As New StreamWriter( _
                "c:\Documents and Settings\gary\My Documents\Visual Studio Projects\SunCls\out.txt")
        Dim Pn As VectorCls
        Dim Pn48 As VectorCls
        Dim Vsun As VectorCls
        Dim TiltNormal As Double = (90 - 15) * RadPerDeg ' Normal vector is at 90 deg to Elev angle
        Dim TiltNormal48 As Double = (90 - 48) * RadPerDeg ' Normal vector to the 45 deg tilt panel

        Pn = VectorCls.AzElevVector(-90.0 / DegPerRad, TiltNormal)  ' ie tilted to west at 15 deg 
        Pn48 = VectorCls.AzElevVector(0.0, TiltNormal48)

        Day = 21
        Month = 1
        Year = 2003
        AST = 12
        Longa = 0
        lat = 45 / DegPerRad
        Alt = 0

        sw.WriteLine("Comparison of panel at az = West, Tilt = 15 deg to a panel at Az = 0, Tilt = Lat")
        sw.WriteLine()

        Dim Sun1 As New SunCls(Day, Month, Year, AST, Longa, lat, Alt)
        Dim Az, Elev As Double
        Dim Idn As Double
        Dim Idir, Idir48 As Double      ' direct component of radiation on panel corrected for incident angle
        Dim Idif As Double      ' diffuse componet of radiation on panel
        Dim Itot, Itot48 As Double      ' total radiation on panel for this day, hour...
        Dim Icum, IcumYr As Double
        Dim Icum48, IcumYr48 As Double

        IcumYr = 0
        IcumYr48 = 0

        For Month = 1 To 12
            Icum = 0
            Icum48 = 0

            Sun1.Month = Month

            'find sunrise and sunset fot day
            Dim sr, ss As Double
            sr = Sun1.Sunrise
            sr = [Decimal].Floor(sr)
            ss = Sun1.Sunset
            ss = [Decimal].Floor(ss) + 1

            Dim hr As Double

            sw.WriteLine("Month Hr    Az  Elev   Idn   Dir   Idif   Itot | Idir48  Idif   Itot48")
            For hr = sr To ss Step 1.0

                Sun1.ASThr = hr
                Az = Sun1.AzimuthAng            ' this will give + East az angles
                Elev = Sun1.AltAng

                If Elev > 0 Then

                    ' define a vector toward the sun
                    Vsun = Vsun.AzElevVector(Az, Elev)
                    ' get sun properties for this time
                    Idn = Sun1.Idn
                    Idif = Sun1.Idiffuse

                    ' calc radiation on West facing 15 deg panel
                    Idir = Sun1.Idn * Vsun.Dot(Pn)
                    If Idir < 0 Then Idir = 0 ' sun coming from behind panel gives neg values for Idn
                    Itot = Idir + Idif
                    Icum = Icum + Itot

                    ' calc radiation on South facing 45 deg panel
                    Idir48 = Sun1.Idn * Vsun.Dot(Pn48)
                    If Idir48 < 0 Then Idir48 = 0 ' sun coming from behind panel gives neg values for Idn
                    Itot48 = Idir48 + Idif
                    Icum48 = Icum48 + Itot48

                    sw.WriteLine( _
                    "{0,4:N0}{1,5:N1}{2,5:N0}{3,5:N0} {4,6:N0} {5,6:N0} {6,6:N0} {7,6:N0} {8,6:N0} {9,6:N0} {10,6:N0}", _
                            Month, hr, Az * DegPerRad, Elev * DegPerRad, Idn, Idir, Idif, Itot, _
                                                                            Idir48, Idif, Itot48)
                End If

            Next
            sw.WriteLine(" Month   Day    Icum    Icum45")
            sw.WriteLine("  {0,6:D} {1,6:D}  {2,6:N0}  {3,6:N0}", _
                            Month, Day, Icum, Icum48)
            IcumYr = IcumYr + Icum * 30
            IcumYr48 = IcumYr48 + Icum48 * 30
        Next

        sw.WriteLine("IcumYr = {0,10:N0}     IcumYr45 = {1,10:N0}", IcumYr, IcumYr48)
        sw.Close()

        Console.ReadLine()

    End Sub

End Module
