
 'Solar Analysis Tools -
 'Copyright (C) 2005 Gary Reysa (gary@BuildItSolar.com)

 ' This program is free software; you can redistribute it and/or modify it
 ' under the terms of the GNU General Public License as published by the Free
 ' Software Foundation; either version 2 of the License, or (at your option)
 ' any later version.

 ' This program is distributed in the hope that it will be useful and encourage
 ' further development of solar tools, but   WITHOUT ANY WARRANTY; without even 
 ' the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 ' See the GNU General Public License   for more details.



' A little program to test and demonstrate the TMY class
Imports System.io

Module TMYtest
    Dim TMY As New TMYcls


' output a table for the passed day showing some daily wx stats read from the TMY class
Sub ADay(ByVal Month As Short, ByVal Day As Short)
    Dim TdbLow, TdbHi, MaxIdn As Single
    Dim TdbSum As Single
    Dim Hr As Short
    Dim T As TMYstruc

    Console.WriteLine("Hourly summary of TMY for month/day: " & Month & "/" & Day)
    Console.WriteLine(TMY.TMYHeader())
    Console.WriteLine()
    Console.WriteLine("Month Day     Hr   Tdb    Idn  SkyCov Precip")

    TdbSum = 0
    TdbLow = +500
    TdbHi = -500
    For Hr = 1 To 24
            T = TMY.TMYrecForDate(Month, Day, Hr)

            If T.Tdb < TdbLow Then TdbLow = T.Tdb
            If T.Tdb > TdbHi Then TdbHi = T.Tdb
            If T.Idn > MaxIdn Then MaxIdn = T.Idn

            TdbSum += T.Tdb
            Console.WriteLine("{0,4} {1,4}   {2,4} {3,5:F1} {4,6:F1}  {5,4}   {6,6:F2} ", _
              T.Month, T.Day, T.Hour, T.Tdb, T.Idn, T.SkyCov, T.Precip)
    Next
        ' output a line for the day
    Console.WriteLine()
    Console.WriteLine("Tdb: Low{0,5:F1}  High{1,5:F1}  Avg{2,5:F1}", TdbLow, TdbHi, TdbSum / 24.0)
End Sub  ' ADay


' The TMY Record fields:
                ' TMY structure data fields -- there is one of these records for each hour of year
                'Dim Year As Short               'p 2 - 3  Year that data came from 69 to 90ish
                'Dim Month As Single             'p 4 - 5  Month 
                'Dim Day As Short                'p 6 - 7  Day
                'Dim Hour As Short               'p 8 - 9  Hour
                'Dim Ihorzext As Single          'p 10-13  Extraterrestrial Horz Rad (BTU/hr-ft^2)
                'Dim Idnext As Single            'p 14-17  Extraterrestrial Direct Normal Rad (BTU/hr-ft^2)
                'Dim Ihorzglo As Single          'p 18-21  Global Horz Rad (direct + diffuse) (BTU/hr-ft^2)
                'Dim Idn As Single               'p 24-27  Direct Normal Radiation (BTU/hr-ft^2)
                'Dim Ihorzdif As Single          'p 30-33  Diffuse rad on horz surface (BTU/hr-ft^2)
                'Dim ILhorzglo As Single         'p 36-39  Total Illuminance on horz surf in (lux)
                'Dim ILdn As Single              'p 42-45  Direct normal illuminance in (lux)
                'Dim ILhorzdif As Single         'p 48-51  Diffuse illuminance on horz surf (lux)
                'Dim SkyCov As Short             'p 60-65  Amount of sky dome covered in tenths
                'Dim Tdb As Single               'p 68-71  Tempeerature - dry buld  (deg F)
                'Dim Tdp As Single               'p 74-77  Temperature - dew pointbuld deg F
                'Dim RH As Short                 'p 80-82  Relative Humidity (0 to 100)
                'Dim Patm As Single              'p 85-88  Atmospheric pressure (lb/in^2)
                'Dim WindDir As Short            'p 91-93  Wind Direction (0 to 360) calm is a zero
                'Dim WindSpd As Single           'p 96-98  Wind speed in tenths of (MPH)
                'Dim Viz As Single               'p 101-104 Visibility in tenths of miles
                'Dim Ceil As Single              'p 107-111 Ceiling in ft (-1 indicates ulimited ceiling)
                'Dim WxNow As String             'p 114-123 Present weather in a 10 diget code
                'Dim Precip As Single            'p 124-126 Water precip in hour   (inches )     -- see Note 1
                'Dim SnowDep As Single           'p 134-136 Snow depth in (inches) (for day or for hour?)
                'Dim LastSnow As Short           'p 139-140 Days since last snowfall 
    Sub Main()

    'note -- the next line assumes 1) that current dir is set to the projects "bin" dir, 
    '        and 2) that there is a TMY file named Billings.TM2 in the project dir
    '  you can take the next line out as long as the file name in the TMY.ReadTMYfile points 
    '  to a valid TM2 weather file
    My.Computer.FileSystem.CurrentDirectory = Directory.GetParent(My.Computer.FileSystem.CurrentDirectory).FullName

        If (TMY.ReadTMYFile("Billings.TM2")) Then
                ADay(11, 4)
        Else
            Console.WriteLine("bad tmy file")
        End If

        Dim T As New TMYstruc
        Dim Tix As Integer
        T = TMY.TMYrecForDate(11, 3, 3)

        Tix = TMY.TMYrecIndexForDate(12, 31, 24)
        Console.ReadLine()
    End Sub

End Module
